> ## Documentation Index
> Fetch the complete documentation index at: https://docs.checkfu.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get an AutomationRun trace

> Read the joined, content-free execution trace for one AutomationRun in ANY state.



## OpenAPI

````yaml /openapi.json get /v1/automation_runs/{id}/trace
openapi: 3.1.0
info:
  title: Checkfu API
  version: '2026-08-31'
  description: >-
    Authentication is declared per operation: API-key, runtime, or connector
    bearer; Automation signature; or credential-free pairing redemption. Every
    general Checkfu REST request requires the dated `Checkfu-Version` header
    (one of: 2026-08-31); the three MCP JSON-RPC transports use
    `MCP-Protocol-Version`, A2A uses `A2A-Version`, and the provider OAuth
    callback carries neither Checkfu header. API keys resolve one Workspace
    without a request selector; authenticated responses identify it with
    `Checkfu-Workspace-Id`.
servers:
  - url: https://api.checkfu.com
security:
  - bearerAuth: []
tags:
  - name: organizations
  - name: sourceRepositories
  - name: tenants
  - name: workspaces
  - name: principals
  - name: principalGroups
  - name: principalAccessCredentials
  - name: apiKeys
  - name: agents
  - name: harnessRuntime
  - name: permissionAssignments
  - name: actionPolicies
  - name: files
  - name: memoryStores
  - name: modelCredentials
  - name: modelRoutingProfiles
  - name: toolSources
  - name: skills
  - name: skillSources
  - name: skillProposals
  - name: instructionProposals
  - name: catalog
  - name: concepts
  - name: support
  - name: connections
  - name: connectionAssignments
  - name: connectedRuntimes
  - name: fileTrees
  - name: collaboration
  - name: automationGraphs
  - name: automations
  - name: actionApprovals
  - name: standingApprovals
  - name: workloadReviewPolicies
  - name: usage
  - name: models
  - name: budgets
  - name: billing
  - name: sessions
  - name: audit
  - name: sessionExports
  - name: runs
  - name: runnerPools
  - name: transcripts
  - name: sessionWatches
  - name: sessionCapsules
  - name: sessionTrajectories
  - name: webhookEndpoints
  - name: integrationGateway
  - name: environments
  - name: vaults
  - name: apiMcp
  - name: a2a
paths:
  /v1/automation_runs/{id}/trace:
    get:
      tags:
        - automations
      summary: Get an AutomationRun trace
      description: >-
        Read the joined, content-free execution trace for one AutomationRun in
        ANY state. Sections join the AutomationRun receipt, the webhook
        filtering decision for its exact delivery payload, admission usage, the
        durable step program (Check and call receipts, child Session parks), the
        originating Session Turn with delivery-screen counts, and structural
        human feedback — each section states its own applicability and the
        Session sections carry the same open, truncated, expired, erased, or ZDR
        completeness honesty as evidence. No messages, explanations, tool
        payloads, or model output are copied into this view.


        Checkfu support posture: alpha; hosted. Required evidence journey:
        automation-firing. Deployment-specific readiness and the latest proven
        release are available from GET /v1/support/capabilities.
      operationId: automations.getAutomationRunTrace
      parameters:
        - name: id
          in: path
          schema:
            $ref: '#/components/schemas/AutomationRunId'
          required: true
        - name: checkfu-version
          in: header
          schema:
            type: string
            enum:
              - '2026-08-31'
          required: true
      responses:
        '200':
          description: AutomationRunTrace
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AutomationRunTrace'
          headers:
            checkfu-workspace-id:
              description: The Workspace resolved from the authenticated bearer credential.
              required: true
              schema:
                $ref: '#/components/schemas/WorkspaceId'
        '400':
          description: Typed Checkfu wire error
          content:
            application/json:
              schema:
                type: object
                required:
                  - error
                properties:
                  error:
                    type: object
                    properties:
                      type:
                        type: string
                        enum:
                          - validation.malformed
                      message:
                        type: string
                      more:
                        type: string
                        enum:
                          - >-
                            https://docs.checkfu.com/reference/errors#validation-malformed
                        description: >-
                          Stable public documentation and remedy for this error
                          type.
                    required:
                      - type
                      - message
                      - more
                    additionalProperties: false
                additionalProperties: false
        '401':
          description: Typed Checkfu wire error
          content:
            application/json:
              schema:
                type: object
                required:
                  - error
                properties:
                  error:
                    type: object
                    required:
                      - type
                      - message
                      - more
                    properties:
                      type:
                        type: string
                        enum:
                          - auth.invalid_key
                      message:
                        type: string
                      more:
                        type: string
                        enum:
                          - >-
                            https://docs.checkfu.com/reference/errors#auth-invalid-key
                        description: >-
                          Stable public documentation and remedy for this error
                          type.
                    additionalProperties: false
                additionalProperties: false
        '403':
          description: >-
            The organization, tenant, or workspace backing this key is
            administratively disabled. | Deployment governance or retention
            policy denied the request.
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    required:
                      - error
                    properties:
                      error:
                        type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - auth.disabled_tenancy
                          message:
                            type: string
                          more:
                            type: string
                            enum:
                              - >-
                                https://docs.checkfu.com/reference/errors#auth-disabled-tenancy
                            description: >-
                              Stable public documentation and remedy for this
                              error type.
                        required:
                          - type
                          - message
                          - more
                        additionalProperties: false
                    additionalProperties: false
                  - $ref: '#/components/schemas/PolicyDeniedError'
        '404':
          description: >-
            The requested resource does not exist in the resolved deployment
            boundary.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidationNotFoundError'
        '429':
          description: Typed Checkfu wire error
          headers:
            retry-after:
              description: >-
                Delay in seconds for rate limits or deployment quotas with a
                known release or UTC reset boundary
              required: false
              schema:
                type: integer
                minimum: 1
          content:
            application/json:
              schema:
                type: object
                required:
                  - error
                properties:
                  error:
                    type: object
                    required:
                      - type
                      - message
                      - more
                    properties:
                      type:
                        type: string
                        enum:
                          - budget.exceeded
                      message:
                        type: string
                      more:
                        type: string
                        enum:
                          - >-
                            https://docs.checkfu.com/reference/errors#budget-exceeded
                        description: >-
                          Stable public documentation and remedy for this error
                          type.
                    additionalProperties: false
                additionalProperties: false
        '500':
          description: >-
            An unexpected internal failure occurred; the message contains an
            opaque incident reference.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RuntimeInternalError'
      security:
        - bearerAuth: []
components:
  schemas:
    AutomationRunId:
      type: string
      pattern: ^afire_[0-9a-f]{32}$
    AutomationRunTrace:
      type: object
      properties:
        authority:
          type: string
          enum:
            - firing_receipt_and_session_event_log
        filtering:
          $ref: '#/components/schemas/AutomationRunTraceFiltering'
        admission:
          type: object
          properties:
            disposition:
              type: string
              enum:
                - not_applicable
                - admitted
            check_configured:
              type: boolean
            check_usage:
              anyOf:
                - $ref: '#/components/schemas/Objects_86'
                - type: 'null'
            attempt_count:
              type: integer
              minimum: 0
          required:
            - disposition
            - check_configured
            - check_usage
            - attempt_count
          additionalProperties: false
        steps:
          $ref: '#/components/schemas/AutomationRunTraceSteps'
        children:
          $ref: '#/components/schemas/AutomationRunTraceChildren'
        execution:
          $ref: '#/components/schemas/AutomationRunTraceExecution'
        delivery:
          $ref: '#/components/schemas/AutomationRunTraceDelivery'
        feedback:
          type: object
          properties:
            total:
              type: integer
              minimum: 0
            by_disposition:
              $ref: '#/components/schemas/Objects_144'
          required:
            - total
            - by_disposition
          additionalProperties: false
        completeness:
          $ref: '#/components/schemas/AutomationRunTraceCompleteness'
        run:
          $ref: '#/components/schemas/AutomationRun_1'
        workspace_id:
          $ref: '#/components/schemas/WorkspaceId'
      required:
        - authority
        - filtering
        - admission
        - steps
        - children
        - execution
        - delivery
        - feedback
        - completeness
        - run
        - workspace_id
      additionalProperties: false
    WorkspaceId:
      type: string
      pattern: ^wrkspc_[0-9a-f]{32}$
    PolicyDeniedError:
      type: object
      properties:
        error:
          type: object
          properties:
            type:
              type: string
              enum:
                - policy.denied
            message:
              type: string
            more:
              type: string
              enum:
                - https://docs.checkfu.com/reference/errors#policy-denied
              description: Stable public documentation and remedy for this error type.
          required:
            - type
            - message
            - more
          additionalProperties: false
      required:
        - error
      additionalProperties: false
      description: Deployment governance or retention policy denied the request.
    ValidationNotFoundError:
      type: object
      properties:
        error:
          type: object
          properties:
            type:
              type: string
              enum:
                - validation.not_found
            message:
              type: string
            more:
              type: string
              enum:
                - https://docs.checkfu.com/reference/errors#validation-not-found
              description: Stable public documentation and remedy for this error type.
          required:
            - type
            - message
            - more
          additionalProperties: false
      required:
        - error
      additionalProperties: false
      description: >-
        The requested resource does not exist in the resolved deployment
        boundary.
    RuntimeInternalError:
      type: object
      properties:
        error:
          type: object
          properties:
            type:
              type: string
              enum:
                - runtime.internal
            message:
              type: string
            more:
              type: string
              enum:
                - https://docs.checkfu.com/reference/errors#runtime-internal
              description: Stable public documentation and remedy for this error type.
          required:
            - type
            - message
            - more
          additionalProperties: false
      required:
        - error
      additionalProperties: false
      description: >-
        An unexpected internal failure occurred; the message contains an opaque
        incident reference.
    AutomationRunTraceFiltering:
      anyOf:
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - false
          required:
            - applicable
          additionalProperties: false
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - true
            payload_fingerprint:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            filtered_record:
              anyOf:
                - type: object
                  properties:
                    id:
                      type: string
                      pattern: ^afilt_[0-9a-f]{32}$
                    reason:
                      $ref: '#/components/schemas/Union_257'
                    received_at:
                      type: string
                    check_usage:
                      anyOf:
                        - $ref: '#/components/schemas/Objects_86'
                        - type: 'null'
                  required:
                    - id
                    - reason
                    - received_at
                    - check_usage
                  additionalProperties: false
                - type: 'null'
          required:
            - applicable
            - payload_fingerprint
            - filtered_record
          additionalProperties: false
    Objects_86:
      type: object
      properties:
        input_tokens:
          type: integer
          minimum: 0
        cached_input_tokens:
          type: integer
          minimum: 0
        cache_write_input_tokens:
          type: integer
          minimum: 0
        output_tokens:
          type: integer
          minimum: 0
        reasoning_output_tokens:
          type: integer
          minimum: 0
        total_tokens:
          type: integer
          minimum: 0
      required:
        - input_tokens
        - cached_input_tokens
        - cache_write_input_tokens
        - output_tokens
        - reasoning_output_tokens
        - total_tokens
      additionalProperties: false
    AutomationRunTraceSteps:
      anyOf:
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - false
          required:
            - applicable
          additionalProperties: false
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - true
            state:
              type: string
              enum:
                - pending
                - settled
                - terminal
            result:
              anyOf:
                - type: string
                  enum:
                    - completed
                    - failed
                    - denied
                    - rejected
                - type: 'null'
            attempt_count:
              type: integer
              minimum: 0
            outcomes:
              type: array
              items:
                $ref: '#/components/schemas/Union_261'
            check_results:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepCheckResult'
            call_results:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepCallResult'
            session_query_receipts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepSessionQueryReceipt'
              allOf:
                - maxItems: 20
            memory_write_receipts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepMemoryWriteReceipt'
              allOf:
                - maxItems: 20
            skill_proposal_receipts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepSkillProposalReceipt'
              allOf:
                - maxItems: 20
            skill_proposal_observations:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepSkillProposalObservation'
              allOf:
                - maxItems: 20
            json_receipts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepJsonReceipt'
              allOf:
                - maxItems: 20
            skill_read_receipts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepSkillReadReceipt'
              allOf:
                - maxItems: 20
            processing_recovery_receipts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepProcessingRecoveryReceipt'
              allOf:
                - maxItems: 20
            step_attempts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepAttempts'
            step_items:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepItems'
          required:
            - applicable
            - state
            - result
            - attempt_count
            - outcomes
            - check_results
            - call_results
          additionalProperties: false
    AutomationRunTraceChildren:
      anyOf:
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - false
          required:
            - applicable
          additionalProperties: false
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - true
            session_parks:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepChildSessionPark'
            session_receipts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepChildSessionPark'
              allOf:
                - maxItems: 5000
            pending_session:
              anyOf:
                - $ref: '#/components/schemas/SessionId'
                - type: 'null'
          required:
            - applicable
            - session_parks
            - pending_session
          additionalProperties: false
    AutomationRunTraceExecution:
      anyOf:
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - false
          required:
            - applicable
          additionalProperties: false
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - true
            session_id:
              $ref: '#/components/schemas/SessionId'
            initial_run_id:
              $ref: '#/components/schemas/RunId'
            run_count:
              type: integer
              minimum: 0
            terminal_status:
              anyOf:
                - type: string
                - type: 'null'
          required:
            - applicable
            - session_id
            - initial_run_id
            - run_count
            - terminal_status
          additionalProperties: false
    AutomationRunTraceDelivery:
      anyOf:
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - false
          required:
            - applicable
          additionalProperties: false
        - type: object
          properties:
            applicable:
              type: boolean
              enum:
                - true
            screened_messages:
              type: integer
              minimum: 0
            passed:
              type: integer
              minimum: 0
            blocked:
              type: integer
              minimum: 0
            screen_failed:
              type: integer
              minimum: 0
          required:
            - applicable
            - screened_messages
            - passed
            - blocked
            - screen_failed
          additionalProperties: false
    Objects_144:
      type: object
      properties:
        useful:
          type: integer
          minimum: 0
        noisy:
          type: integer
          minimum: 0
        incorrect:
          type: integer
          minimum: 0
        too_late:
          type: integer
          minimum: 0
        already_handled:
          type: integer
          minimum: 0
      required:
        - useful
        - noisy
        - incorrect
        - too_late
        - already_handled
      additionalProperties: false
    AutomationRunTraceCompleteness:
      anyOf:
        - type: object
          properties:
            status:
              type: string
              enum:
                - complete
            through_sequence:
              type: integer
              minimum: 0
          required:
            - status
            - through_sequence
          additionalProperties: false
        - type: object
          properties:
            status:
              type: string
              enum:
                - incomplete
            reason:
              type: string
              enum:
                - open
                - truncated
                - expired
                - erased
                - zdr
                - not_applicable
            through_sequence:
              anyOf:
                - type: integer
                  minimum: 0
                - type: 'null'
          required:
            - status
            - reason
            - through_sequence
          additionalProperties: false
    AutomationRun_1:
      type: object
      properties:
        type:
          type: string
          enum:
            - automation_run
        id:
          $ref: '#/components/schemas/AutomationRunId'
        automation_id:
          $ref: '#/components/schemas/AutomationId'
        definition_revision:
          $ref: '#/components/schemas/Union_258'
        agent:
          $ref: '#/components/schemas/Union_259'
        steps:
          $ref: '#/components/schemas/Union_260'
        session_id:
          $ref: '#/components/schemas/Union_262'
        error:
          $ref: '#/components/schemas/Union_263'
        trigger_context:
          $ref: '#/components/schemas/Union_264'
        created_at:
          type: string
        updated_at:
          type: string
        admission:
          $ref: '#/components/schemas/Objects_146'
        execution:
          $ref: '#/components/schemas/Objects_147'
        quality:
          $ref: '#/components/schemas/Objects_148'
        release:
          $ref: '#/components/schemas/Objects_149'
        settlement:
          $ref: '#/components/schemas/Objects_150'
        cleanup:
          $ref: '#/components/schemas/Objects_157'
        effects:
          $ref: '#/components/schemas/Arrays_41'
        children:
          $ref: '#/components/schemas/Arrays_42'
      required:
        - type
        - id
        - automation_id
        - definition_revision
        - agent
        - steps
        - session_id
        - error
        - trigger_context
        - created_at
        - updated_at
        - admission
        - execution
        - quality
        - release
        - settlement
        - cleanup
        - effects
        - children
      additionalProperties: false
    Union_257:
      type: string
      enum:
        - predicate_unmatched
        - check_drop
        - check_uncertain
        - check_failed
    Union_261:
      anyOf:
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - completed
            unchanged:
              type: boolean
              enum:
                - true
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - skipped
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - rejected
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - failed
            reason:
              $ref: '#/components/schemas/AutomationStepFailureReason'
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - awaiting_approval
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - waiting
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - running
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - denied
          required:
            - step
            - kind
          additionalProperties: false
        - type: object
          properties:
            step:
              type: string
              allOf:
                - minLength: 1
                - maxLength: 64
                - pattern: ^[A-Za-z0-9_]+$
            kind:
              type: string
              enum:
                - decision
            branch:
              type: string
              enum:
                - continue
                - otherwise
                - uncertain
                - error
          required:
            - step
            - kind
            - branch
          additionalProperties: false
    AutomationStepCheckResult:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        operation:
          type: string
          enum:
            - condition
            - action
        resolution:
          type: string
          enum:
            - admit
            - deny
            - uncertain
            - failed
        usage:
          anyOf:
            - $ref: '#/components/schemas/Objects_86'
            - type: 'null'
      required:
        - step
        - operation
        - resolution
        - usage
      additionalProperties: false
    AutomationStepCallResult:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        resolution:
          type: string
          enum:
            - succeeded
            - failed
        status:
          anyOf:
            - type: integer
              allOf:
                - minimum: 100
                  maximum: 599
            - type: 'null'
      required:
        - step
        - resolution
        - status
      additionalProperties: false
    AutomationStepSessionQueryReceipt:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        agent:
          $ref: '#/components/schemas/AgentId'
        disposition:
          type: string
          enum:
            - empty
            - selected
        after_sequence:
          type: integer
          allOf:
            - minimum: 0
            - maximum: 9007199254740991
        through_sequence:
          type: integer
          allOf:
            - minimum: 0
            - maximum: 9007199254740991
        has_more:
          type: boolean
        sources:
          type: array
          items:
            type: object
            properties:
              session:
                $ref: '#/components/schemas/SessionId'
              source_sequence:
                type: integer
                allOf:
                  - minimum: 0
                  - maximum: 9007199254740991
              change_sequence:
                type: integer
                allOf:
                  - minimum: 0
                  - maximum: 9007199254740991
              range:
                $ref: '#/components/schemas/AutomationSessionEvidenceRange'
            required:
              - session
              - source_sequence
              - change_sequence
            additionalProperties: false
          allOf:
            - maxItems: 100
      required:
        - step
        - agent
        - disposition
        - after_sequence
        - through_sequence
        - has_more
        - sources
      additionalProperties: false
    AutomationStepMemoryWriteReceipt:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        store:
          $ref: '#/components/schemas/MemoryStoreId'
        disposition:
          type: string
          enum:
            - applied
            - noop
            - replayed
            - proposed
        tree_hash:
          anyOf:
            - type: string
              pattern: ^sha256:[0-9a-f]{64}$
            - type: 'null'
        proposal:
          $ref: '#/components/schemas/MemoryProposalId'
        changed_path_count:
          type: integer
          minimum: 0
        source_queries:
          type: array
          items:
            type: string
            allOf:
              - minLength: 1
              - maxLength: 64
              - pattern: ^[A-Za-z0-9_]+$
          allOf:
            - maxItems: 20
      required:
        - step
        - store
        - disposition
        - tree_hash
        - changed_path_count
        - source_queries
      additionalProperties: false
    AutomationStepSkillProposalReceipt:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        query_step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        result:
          $ref: '#/components/schemas/AutomationSkillProposalReceipt'
      required:
        - step
        - query_step
        - result
      additionalProperties: false
    AutomationStepSkillProposalObservation:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        proposal_step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        result:
          $ref: '#/components/schemas/AutomationSkillProposalObservation'
      required:
        - step
        - proposal_step
        - result
      additionalProperties: false
    AutomationStepJsonReceipt:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        input_bindings:
          $ref: '#/components/schemas/AutomationJsonInputBindings'
        policy_version:
          type: number
          enum:
            - 1
        input_sha256:
          type: string
          pattern: ^sha256:[0-9a-f]{64}$
        schema_sha256:
          type: string
          pattern: ^sha256:[0-9a-f]{64}$
        output_sha256:
          type: string
          pattern: ^sha256:[0-9a-f]{64}$
      required:
        - step
        - input_bindings
        - policy_version
        - input_sha256
        - schema_sha256
        - output_sha256
      additionalProperties: false
    AutomationStepSkillReadReceipt:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        skill:
          $ref: '#/components/schemas/SkillId'
        version:
          type: integer
          allOf:
            - minimum: 1
              maximum: 9007199254740991
      required:
        - step
        - skill
        - version
      additionalProperties: false
    AutomationStepProcessingRecoveryReceipt:
      type: object
      properties:
        query_step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        previous_firing:
          $ref: '#/components/schemas/AutomationFiringId'
        effect_firing:
          $ref: '#/components/schemas/AutomationFiringId'
        restored_steps:
          type: array
          items:
            type: string
            allOf:
              - minLength: 1
              - maxLength: 64
              - pattern: ^[A-Za-z0-9_]+$
          allOf:
            - maxItems: 20
      required:
        - query_step
        - previous_firing
        - effect_firing
      additionalProperties: false
    AutomationStepAttempts:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        attempts:
          type: integer
          allOf:
            - minimum: 2
              maximum: 5
      required:
        - step
        - attempts
      additionalProperties: false
    AutomationStepItems:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        total:
          type: integer
          minimum: 0
        started:
          type: integer
          allOf:
            - minimum: 0
              maximum: 50
        completed:
          type: integer
          allOf:
            - minimum: 0
              maximum: 50
        failed:
          type: integer
          allOf:
            - minimum: 0
              maximum: 50
        rejected:
          type: integer
          allOf:
            - minimum: 0
              maximum: 50
        refusal:
          type: string
          enum:
            - items_missing
            - items_not_array
            - too_many_items
      required:
        - step
        - total
        - started
        - completed
        - failed
        - rejected
      additionalProperties: false
    AutomationStepChildSessionPark:
      type: object
      properties:
        step:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 64
            - pattern: ^[A-Za-z0-9_]+$
        session:
          $ref: '#/components/schemas/SessionId'
      required:
        - step
        - session
      additionalProperties: false
    SessionId:
      type: string
      pattern: ^sess_[0-9a-f]{32}$
    RunId:
      type: string
      pattern: ^run_[0-9a-f]{32}$
    AutomationId:
      type: string
      pattern: ^auto_[0-9a-f]{32}$
    Union_258:
      anyOf:
        - type: integer
          exclusiveMinimum: 0
        - type: 'null'
    Union_259:
      anyOf:
        - type: object
          properties:
            type:
              type: string
              enum:
                - agent
            id:
              $ref: '#/components/schemas/AgentId'
            version:
              type: integer
              exclusiveMinimum: 0
          required:
            - type
            - id
            - version
          additionalProperties: false
        - type: 'null'
    Union_260:
      anyOf:
        - type: object
          properties:
            program_fingerprint:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            state:
              type: string
              enum:
                - pending
                - settled
                - terminal
            result:
              anyOf:
                - type: string
                  enum:
                    - completed
                    - failed
                    - denied
                    - rejected
                - type: 'null'
            steps:
              type: array
              items:
                $ref: '#/components/schemas/Union_261'
            wake_at:
              anyOf:
                - type: string
                - type: 'null'
            step_attempts:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepAttempts'
            step_items:
              type: array
              items:
                $ref: '#/components/schemas/AutomationStepItems'
          required:
            - state
            - result
            - steps
            - wake_at
          additionalProperties: false
        - type: 'null'
    Union_262:
      anyOf:
        - $ref: '#/components/schemas/SessionId'
        - type: 'null'
    Union_263:
      anyOf:
        - $ref: '#/components/schemas/Objects_145'
        - type: 'null'
    Union_264:
      anyOf:
        - type: object
          properties:
            type:
              type: string
              enum:
                - manual
          required:
            - type
          additionalProperties: false
        - type: object
          properties:
            type:
              type: string
              enum:
                - schedule
            scheduled_at:
              type: string
          required:
            - type
            - scheduled_at
          additionalProperties: false
        - type: object
          properties:
            type:
              type: string
              enum:
                - webhook
            event_identity_digest:
              anyOf:
                - type: string
                - type: 'null'
          required:
            - type
            - event_identity_digest
          additionalProperties: false
        - type: object
          properties:
            type:
              type: string
              enum:
                - subscription
            source_id:
              anyOf:
                - type: string
                - type: 'null'
          required:
            - type
            - source_id
          additionalProperties: false
    Objects_146:
      type: object
      properties:
        status:
          type: string
          enum:
            - pending
            - accepted
            - rejected
            - canceled
            - unknown
        error:
          anyOf:
            - $ref: '#/components/schemas/Objects_145'
            - type: 'null'
      required:
        - status
        - error
      additionalProperties: false
    Objects_147:
      type: object
      properties:
        status:
          type: string
          enum:
            - not_started
            - running
            - waiting
            - completed
            - failed
            - canceled
            - unknown
        wait_reason:
          anyOf:
            - type: string
              enum:
                - approval
                - input
                - timer
                - capacity
                - reconciliation
            - type: 'null'
        cancel_status:
          type: string
          enum:
            - not_requested
            - requested
            - stopped
            - completed_before_stop
            - unconfirmed
      required:
        - status
        - wait_reason
        - cancel_status
      additionalProperties: false
    Objects_148:
      type: object
      properties:
        status:
          type: string
          enum:
            - not_requested
            - pending
            - accepted
            - exhausted
            - indeterminate
            - error
        rounds_completed:
          type: integer
          minimum: 0
        max_rounds:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
      required:
        - status
        - rounds_completed
        - max_rounds
      additionalProperties: false
    Objects_149:
      type: object
      properties:
        status:
          type: string
          enum:
            - not_requested
            - pending
            - released
            - partially_released
            - withheld
            - unavailable
            - erased
        result:
          anyOf:
            - type: object
              properties:
                session_id:
                  $ref: '#/components/schemas/SessionId'
                input_id:
                  $ref: '#/components/schemas/EventId'
              required:
                - session_id
                - input_id
              additionalProperties: false
            - type: 'null'
      required:
        - status
        - result
      additionalProperties: false
    Objects_150:
      type: object
      properties:
        status:
          type: string
          enum:
            - pending
            - settled
            - unknown
        usage:
          anyOf:
            - type: object
              properties:
                data:
                  type: array
                  items:
                    $ref: '#/components/schemas/UsageEntrySubject'
                next_page:
                  anyOf:
                    - type: string
                    - type: 'null'
              required:
                - data
                - next_page
              additionalProperties: false
            - type: 'null'
      required:
        - status
        - usage
      additionalProperties: false
    Objects_157:
      type: object
      properties:
        status:
          type: string
          enum:
            - not_required
            - pending
            - completed
            - blocked
      required:
        - status
      additionalProperties: false
    Arrays_41:
      type: array
      items:
        anyOf:
          - type: object
            properties:
              type:
                type: string
                enum:
                  - memory_proposal
              memory_store_id:
                type: string
              proposal_id:
                type: string
            required:
              - type
              - memory_store_id
              - proposal_id
            additionalProperties: false
          - type: object
            properties:
              type:
                type: string
                enum:
                  - memory_publication
              memory_store_id:
                type: string
              snapshot_id:
                type: string
              disposition:
                type: string
                enum:
                  - published
                  - unchanged
            required:
              - type
              - memory_store_id
              - snapshot_id
              - disposition
            additionalProperties: false
          - type: object
            properties:
              type:
                type: string
                enum:
                  - skill_proposal
              proposal_id:
                type: string
              status:
                type: string
                enum:
                  - created
                  - verified
                  - submitted
                  - pending_adoption
                  - rejected
                  - unknown
            required:
              - type
              - proposal_id
              - status
            additionalProperties: false
          - type: object
            properties:
              type:
                type: string
                enum:
                  - skill_adoption
              skill_id:
                type: string
              version:
                type: integer
              disposition:
                type: string
                enum:
                  - adopted
                  - unchanged
            required:
              - type
              - skill_id
              - version
              - disposition
            additionalProperties: false
    Arrays_42:
      type: array
      items:
        type: object
        properties:
          step_id:
            anyOf:
              - type: string
              - type: 'null'
          session_id:
            $ref: '#/components/schemas/SessionId'
          input_id:
            anyOf:
              - $ref: '#/components/schemas/EventId'
              - type: 'null'
          run_id:
            anyOf:
              - $ref: '#/components/schemas/RunId'
              - type: 'null'
          status:
            type: string
            enum:
              - queued
              - running
              - waiting
              - completed
              - failed
              - canceled
              - unknown
        required:
          - step_id
          - session_id
          - input_id
          - run_id
          - status
        additionalProperties: false
    AutomationStepFailureReason:
      type: string
      pattern: ^[a-z][a-z0-9_]{0,127}$
    AgentId:
      type: string
      pattern: ^agent_[0-9a-f]{32}$
    AutomationSessionEvidenceRange:
      type: object
      properties:
        policy_version:
          type: string
          enum:
            - automation-session-range-1
        frontier:
          anyOf:
            - $ref: '#/components/schemas/SessionEvidenceFrontier'
            - type: 'null'
        after_sequence:
          type: integer
          allOf:
            - minimum: 0
            - maximum: 9007199254740991
        through_sequence:
          type: integer
          allOf:
            - minimum: 0
            - maximum: 9007199254740991
        complete:
          type: boolean
        evidence_sha256:
          type: string
          pattern: ^sha256:[0-9a-f]{64}$
      required:
        - policy_version
        - frontier
        - after_sequence
        - through_sequence
        - complete
        - evidence_sha256
      additionalProperties: false
    MemoryStoreId:
      type: string
      pattern: ^memstore_[0-9a-f]{32}$
    MemoryProposalId:
      type: string
      pattern: ^mprop_[0-9a-f]{32}$
    AutomationSkillProposalReceipt:
      anyOf:
        - type: object
          properties:
            disposition:
              type: string
              enum:
                - drafted
            proposal:
              $ref: '#/components/schemas/SkillProposalId'
            content_sha256:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            usage:
              $ref: '#/components/schemas/Objects_86'
          required:
            - disposition
            - proposal
            - content_sha256
            - usage
          additionalProperties: false
        - type: object
          properties:
            disposition:
              type: string
              enum:
                - empty
            proposal:
              type: 'null'
            content_sha256:
              type: 'null'
            usage:
              type: 'null'
          required:
            - disposition
            - proposal
            - content_sha256
            - usage
          additionalProperties: false
    AutomationSkillProposalObservation:
      anyOf:
        - type: object
          properties:
            disposition:
              type: string
              enum:
                - empty
            proposal:
              type: 'null'
            content_sha256:
              type: 'null'
          required:
            - disposition
            - proposal
            - content_sha256
          additionalProperties: false
        - type: object
          properties:
            disposition:
              type: string
              enum:
                - pending
            proposal:
              $ref: '#/components/schemas/SkillProposalId'
            content_sha256:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
          required:
            - disposition
            - proposal
            - content_sha256
          additionalProperties: false
        - type: object
          properties:
            disposition:
              type: string
              enum:
                - evidence
            proposal:
              $ref: '#/components/schemas/SkillProposalId'
            content_sha256:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            skill:
              $ref: '#/components/schemas/SkillId'
            version:
              type: integer
              exclusiveMinimum: 0
            association:
              type: string
              enum:
                - recorded
                - observed
          required:
            - disposition
            - proposal
            - content_sha256
            - skill
            - version
            - association
          additionalProperties: false
    AutomationJsonInputBindings:
      type: object
      additionalProperties:
        $ref: '#/components/schemas/AutomationAgentOutputBinding'
      allOf:
        - maxProperties: 32
    SkillId:
      type: string
      pattern: ^skl_[0-9a-f]{32}$
    AutomationFiringId:
      type: string
      pattern: ^afire_[0-9a-f]{32}$
    Objects_145:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/Union_210'
        message:
          type: string
        more:
          type: string
          pattern: ^https:\/\/docs\.checkfu\.com\/reference\/errors#[a-z0-9-]+$
      required:
        - type
        - message
      additionalProperties: false
    EventId:
      type: string
      pattern: ^evt_[0-9a-f]{32}$
    UsageEntrySubject:
      anyOf:
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/UsageEntryId'
            session_id:
              anyOf:
                - $ref: '#/components/schemas/SessionId'
                - type: 'null'
            run:
              anyOf:
                - $ref: '#/components/schemas/RunId'
                - type: 'null'
            attempt:
              type: 'null'
            agent_id:
              anyOf:
                - $ref: '#/components/schemas/AgentId'
                - type: 'null'
            automation_id:
              anyOf:
                - $ref: '#/components/schemas/AutomationId'
                - type: 'null'
            evaluation: false
            execution_origin: false
            sequence:
              type: integer
              exclusiveMinimum: 0
            workspace_id:
              $ref: '#/components/schemas/WorkspaceId'
            principal_id:
              $ref: '#/components/schemas/Union_266'
            anonymous_subject_ref:
              $ref: '#/components/schemas/Union_267'
            recorded_at:
              $ref: '#/components/schemas/UsageTimestamp'
            measurement:
              type: object
              properties:
                kind:
                  type: string
                  enum:
                    - managed_tool
                tool_invocation_id:
                  $ref: '#/components/schemas/ToolInvocationId'
                selection:
                  $ref: '#/components/schemas/ManagedToolSelection'
                origin:
                  anyOf:
                    - type: object
                      properties:
                        origin_type:
                          type: string
                          enum:
                            - session
                        session_id:
                          $ref: '#/components/schemas/SessionId'
                        run:
                          $ref: '#/components/schemas/RunId'
                      required:
                        - origin_type
                        - session_id
                        - run
                      additionalProperties: false
                    - type: object
                      properties:
                        origin_type:
                          type: string
                          enum:
                            - automation
                        automation_id:
                          $ref: '#/components/schemas/AutomationId'
                        automation_firing_id:
                          $ref: '#/components/schemas/AutomationFiringId'
                        automation_step_id:
                          type: string
                          allOf:
                            - minLength: 1
                            - maxLength: 64
                            - pattern: ^[A-Za-z0-9_]+$
                      required:
                        - origin_type
                        - automation_id
                        - automation_firing_id
                        - automation_step_id
                      additionalProperties: false
                    - type: object
                      properties:
                        origin_type:
                          type: string
                          enum:
                            - api
                      required:
                        - origin_type
                      additionalProperties: false
                price:
                  $ref: '#/components/schemas/ManagedToolPrice'
                outcome:
                  anyOf:
                    - type: object
                      properties:
                        outcome_type:
                          type: string
                          enum:
                            - valid_result
                        empty_result:
                          type: boolean
                      required:
                        - outcome_type
                        - empty_result
                      additionalProperties: false
                    - type: object
                      properties:
                        outcome_type:
                          type: string
                          enum:
                            - failed
                            - canceled
                        dispatched:
                          type: boolean
                      required:
                        - outcome_type
                        - dispatched
                      additionalProperties: false
              required:
                - kind
                - tool_invocation_id
                - selection
                - origin
                - price
                - outcome
              additionalProperties: false
            cost:
              type: object
              properties:
                tokens: false
                active_ms: false
                storage_mib_ms: false
                running_ms: false
                managed_tool_calls:
                  type: number
                  enum:
                    - 1
                billed_microusd:
                  type: integer
                  allOf:
                    - minimum: 0
                    - maximum: 9007199254740991
                rounding_remainder_millionths:
                  type: number
                  enum:
                    - 0
              required:
                - managed_tool_calls
                - billed_microusd
                - rounding_remainder_millionths
              additionalProperties: false
          required:
            - id
            - session_id
            - run
            - attempt
            - agent_id
            - sequence
            - workspace_id
            - principal_id
            - anonymous_subject_ref
            - recorded_at
            - measurement
            - cost
          additionalProperties: false
        - anyOf:
            - type: object
              properties:
                id:
                  $ref: '#/components/schemas/UsageEntryId'
                session_id:
                  $ref: '#/components/schemas/SessionId'
                run:
                  $ref: '#/components/schemas/RunId'
                attempt:
                  type: 'null'
                agent_id:
                  $ref: '#/components/schemas/AgentId'
                automation_id:
                  anyOf:
                    - $ref: '#/components/schemas/AutomationId'
                    - type: 'null'
                evaluation: false
                execution_origin:
                  type: string
                  enum:
                    - native_sdk
                sequence:
                  type: integer
                  exclusiveMinimum: 0
                workspace_id:
                  $ref: '#/components/schemas/WorkspaceId'
                principal_id:
                  $ref: '#/components/schemas/Union_266'
                anonymous_subject_ref:
                  $ref: '#/components/schemas/Union_267'
                recorded_at:
                  $ref: '#/components/schemas/UsageTimestamp'
                measurement:
                  $ref: '#/components/schemas/Objects_151'
                cost:
                  $ref: '#/components/schemas/Objects_153'
              required:
                - id
                - session_id
                - run
                - attempt
                - agent_id
                - execution_origin
                - sequence
                - workspace_id
                - principal_id
                - anonymous_subject_ref
                - recorded_at
                - measurement
                - cost
              additionalProperties: false
            - type: object
              properties:
                id:
                  $ref: '#/components/schemas/UsageEntryId'
                session_id:
                  $ref: '#/components/schemas/SessionId'
                run:
                  $ref: '#/components/schemas/RunId'
                attempt:
                  $ref: '#/components/schemas/RunAttemptId'
                agent_id:
                  $ref: '#/components/schemas/AgentId'
                automation_id:
                  anyOf:
                    - $ref: '#/components/schemas/AutomationId'
                    - type: 'null'
                evaluation: false
                execution_origin: false
                sequence:
                  type: integer
                  exclusiveMinimum: 0
                workspace_id:
                  $ref: '#/components/schemas/WorkspaceId'
                principal_id:
                  $ref: '#/components/schemas/Union_266'
                anonymous_subject_ref:
                  $ref: '#/components/schemas/Union_267'
                recorded_at:
                  $ref: '#/components/schemas/UsageTimestamp'
                measurement:
                  $ref: '#/components/schemas/Objects_151'
                cost:
                  $ref: '#/components/schemas/Objects_153'
              required:
                - id
                - session_id
                - run
                - attempt
                - agent_id
                - sequence
                - workspace_id
                - principal_id
                - anonymous_subject_ref
                - recorded_at
                - measurement
                - cost
              additionalProperties: false
            - type: object
              properties:
                id:
                  $ref: '#/components/schemas/UsageEntryId'
                session_id:
                  anyOf:
                    - $ref: '#/components/schemas/SessionId'
                    - type: 'null'
                run:
                  type: 'null'
                attempt:
                  type: 'null'
                agent_id:
                  anyOf:
                    - $ref: '#/components/schemas/AgentId'
                    - type: 'null'
                automation_id:
                  anyOf:
                    - $ref: '#/components/schemas/AutomationId'
                    - type: 'null'
                evaluation:
                  $ref: '#/components/schemas/EvaluationUsageOrigin'
                execution_origin: false
                sequence:
                  type: integer
                  exclusiveMinimum: 0
                workspace_id:
                  $ref: '#/components/schemas/WorkspaceId'
                principal_id:
                  $ref: '#/components/schemas/Union_266'
                anonymous_subject_ref:
                  $ref: '#/components/schemas/Union_267'
                recorded_at:
                  $ref: '#/components/schemas/UsageTimestamp'
                measurement:
                  $ref: '#/components/schemas/Objects_151'
                cost:
                  $ref: '#/components/schemas/Objects_153'
              required:
                - id
                - session_id
                - run
                - attempt
                - agent_id
                - evaluation
                - sequence
                - workspace_id
                - principal_id
                - anonymous_subject_ref
                - recorded_at
                - measurement
                - cost
              additionalProperties: false
        - anyOf:
            - type: object
              properties:
                id:
                  $ref: '#/components/schemas/UsageEntryId'
                session_id:
                  $ref: '#/components/schemas/SessionId'
                run:
                  $ref: '#/components/schemas/RunId'
                attempt:
                  type: 'null'
                agent_id:
                  $ref: '#/components/schemas/AgentId'
                automation_id:
                  anyOf:
                    - $ref: '#/components/schemas/AutomationId'
                    - type: 'null'
                evaluation: false
                execution_origin:
                  type: string
                  enum:
                    - native_sdk
                sequence:
                  type: integer
                  exclusiveMinimum: 0
                workspace_id:
                  $ref: '#/components/schemas/WorkspaceId'
                principal_id:
                  $ref: '#/components/schemas/Union_266'
                anonymous_subject_ref:
                  $ref: '#/components/schemas/Union_267'
                recorded_at:
                  $ref: '#/components/schemas/UsageTimestamp'
                measurement:
                  $ref: '#/components/schemas/Objects_154'
                cost:
                  $ref: '#/components/schemas/Objects_156'
              required:
                - id
                - session_id
                - run
                - attempt
                - agent_id
                - execution_origin
                - sequence
                - workspace_id
                - principal_id
                - anonymous_subject_ref
                - recorded_at
                - measurement
                - cost
              additionalProperties: false
            - type: object
              properties:
                id:
                  $ref: '#/components/schemas/UsageEntryId'
                session_id:
                  $ref: '#/components/schemas/SessionId'
                run:
                  $ref: '#/components/schemas/RunId'
                attempt:
                  $ref: '#/components/schemas/RunAttemptId'
                agent_id:
                  $ref: '#/components/schemas/AgentId'
                automation_id:
                  anyOf:
                    - $ref: '#/components/schemas/AutomationId'
                    - type: 'null'
                evaluation: false
                execution_origin: false
                sequence:
                  type: integer
                  exclusiveMinimum: 0
                workspace_id:
                  $ref: '#/components/schemas/WorkspaceId'
                principal_id:
                  $ref: '#/components/schemas/Union_266'
                anonymous_subject_ref:
                  $ref: '#/components/schemas/Union_267'
                recorded_at:
                  $ref: '#/components/schemas/UsageTimestamp'
                measurement:
                  $ref: '#/components/schemas/Objects_154'
                cost:
                  $ref: '#/components/schemas/Objects_156'
              required:
                - id
                - session_id
                - run
                - attempt
                - agent_id
                - sequence
                - workspace_id
                - principal_id
                - anonymous_subject_ref
                - recorded_at
                - measurement
                - cost
              additionalProperties: false
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/UsageEntryId'
            session_id:
              $ref: '#/components/schemas/SessionId'
            run:
              $ref: '#/components/schemas/RunId'
            attempt:
              $ref: '#/components/schemas/RunAttemptId'
            agent_id:
              $ref: '#/components/schemas/AgentId'
            automation_id:
              anyOf:
                - $ref: '#/components/schemas/AutomationId'
                - type: 'null'
            evaluation: false
            execution_origin: false
            sequence:
              type: integer
              exclusiveMinimum: 0
            workspace_id:
              $ref: '#/components/schemas/WorkspaceId'
            principal_id:
              $ref: '#/components/schemas/Union_266'
            anonymous_subject_ref:
              $ref: '#/components/schemas/Union_267'
            recorded_at:
              $ref: '#/components/schemas/UsageTimestamp'
            measurement:
              $ref: '#/components/schemas/SandboxComputeInterval'
            cost:
              type: object
              properties:
                tokens: false
                active_ms:
                  type: integer
                  minimum: 0
                storage_mib_ms: false
                running_ms: false
                billed_microusd: false
              required:
                - active_ms
              additionalProperties: false
          required:
            - id
            - session_id
            - run
            - attempt
            - agent_id
            - sequence
            - workspace_id
            - principal_id
            - anonymous_subject_ref
            - recorded_at
            - measurement
            - cost
          additionalProperties: false
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/UsageEntryId'
            session_id:
              $ref: '#/components/schemas/SessionId'
            run:
              $ref: '#/components/schemas/RunId'
            attempt:
              $ref: '#/components/schemas/RunAttemptId'
            agent_id:
              $ref: '#/components/schemas/AgentId'
            automation_id:
              anyOf:
                - $ref: '#/components/schemas/AutomationId'
                - type: 'null'
            evaluation: false
            execution_origin: false
            sequence:
              type: integer
              exclusiveMinimum: 0
            workspace_id:
              $ref: '#/components/schemas/WorkspaceId'
            principal_id:
              $ref: '#/components/schemas/Union_266'
            anonymous_subject_ref:
              $ref: '#/components/schemas/Union_267'
            recorded_at:
              $ref: '#/components/schemas/UsageTimestamp'
            measurement:
              $ref: '#/components/schemas/SnapshotRetentionInterval'
            cost:
              type: object
              properties:
                tokens: false
                active_ms: false
                storage_mib_ms:
                  type: integer
                  minimum: 0
                running_ms: false
                billed_microusd: false
              required:
                - storage_mib_ms
              additionalProperties: false
          required:
            - id
            - session_id
            - run
            - attempt
            - agent_id
            - sequence
            - workspace_id
            - principal_id
            - anonymous_subject_ref
            - recorded_at
            - measurement
            - cost
          additionalProperties: false
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/UsageEntryId'
            session_id:
              $ref: '#/components/schemas/SessionId'
            run:
              $ref: '#/components/schemas/RunId'
            attempt:
              $ref: '#/components/schemas/RunAttemptId'
            agent_id:
              $ref: '#/components/schemas/AgentId'
            automation_id:
              anyOf:
                - $ref: '#/components/schemas/AutomationId'
                - type: 'null'
            evaluation: false
            execution_origin: false
            sequence:
              type: integer
              exclusiveMinimum: 0
            workspace_id:
              $ref: '#/components/schemas/WorkspaceId'
            principal_id:
              $ref: '#/components/schemas/Union_266'
            anonymous_subject_ref:
              $ref: '#/components/schemas/Union_267'
            recorded_at:
              $ref: '#/components/schemas/UsageTimestamp'
            measurement:
              $ref: '#/components/schemas/SessionRuntimeInterval'
            cost:
              $ref: '#/components/schemas/Union_270'
          required:
            - id
            - session_id
            - run
            - attempt
            - agent_id
            - sequence
            - workspace_id
            - principal_id
            - anonymous_subject_ref
            - recorded_at
            - measurement
            - cost
          additionalProperties: false
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/UsageEntryId'
            session_id:
              $ref: '#/components/schemas/SessionId'
            run:
              $ref: '#/components/schemas/RunId'
            attempt:
              type: 'null'
            agent_id:
              $ref: '#/components/schemas/AgentId'
            automation_id:
              anyOf:
                - $ref: '#/components/schemas/AutomationId'
                - type: 'null'
            evaluation: false
            execution_origin: false
            sequence:
              type: integer
              exclusiveMinimum: 0
            workspace_id:
              $ref: '#/components/schemas/WorkspaceId'
            principal_id:
              $ref: '#/components/schemas/Union_266'
            anonymous_subject_ref:
              $ref: '#/components/schemas/Union_267'
            recorded_at:
              $ref: '#/components/schemas/UsageTimestamp'
            measurement:
              $ref: '#/components/schemas/SessionRuntimeInterval'
            cost:
              $ref: '#/components/schemas/Union_270'
          required:
            - id
            - session_id
            - run
            - attempt
            - agent_id
            - sequence
            - workspace_id
            - principal_id
            - anonymous_subject_ref
            - recorded_at
            - measurement
            - cost
          additionalProperties: false
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/UsageEntryId'
            session_id:
              $ref: '#/components/schemas/SessionId'
            run:
              $ref: '#/components/schemas/RunId'
            attempt:
              $ref: '#/components/schemas/RunAttemptId'
            agent_id:
              $ref: '#/components/schemas/AgentId'
            automation_id:
              anyOf:
                - $ref: '#/components/schemas/AutomationId'
                - type: 'null'
            evaluation: false
            execution_origin: false
            sequence:
              type: integer
              exclusiveMinimum: 0
            workspace_id:
              $ref: '#/components/schemas/WorkspaceId'
            principal_id:
              $ref: '#/components/schemas/Union_266'
            anonymous_subject_ref:
              $ref: '#/components/schemas/Union_267'
            recorded_at:
              $ref: '#/components/schemas/UsageTimestamp'
            measurement:
              type: object
              properties:
                kind:
                  type: string
                  enum:
                    - web_search
                requests:
                  type: integer
                  minimum: 0
              required:
                - kind
                - requests
              additionalProperties: false
            cost:
              type: object
              properties:
                tokens: false
                active_ms: false
                storage_mib_ms: false
                running_ms: false
                requests:
                  type: integer
                  minimum: 0
                billed_microusd:
                  type: integer
                  allOf:
                    - minimum: 0
                    - maximum: 9007199254740991
                rounding_remainder_millionths:
                  type: integer
                  minimum: 0
              required:
                - requests
                - billed_microusd
                - rounding_remainder_millionths
              additionalProperties: false
          required:
            - id
            - session_id
            - run
            - attempt
            - agent_id
            - sequence
            - workspace_id
            - principal_id
            - anonymous_subject_ref
            - recorded_at
            - measurement
            - cost
          additionalProperties: false
    SessionEvidenceFrontier:
      type: object
      properties:
        event:
          $ref: '#/components/schemas/EventId'
        through_sequence:
          type: integer
          allOf:
            - exclusiveMinimum: 0
            - maximum: 9007199254740991
        primary_thread:
          anyOf:
            - $ref: '#/components/schemas/SessionThreadId'
            - type: 'null'
      required:
        - event
        - through_sequence
        - primary_thread
      additionalProperties: false
      description: >-
        committed Session event identity and inclusive sequence for frozen
        evidence; independent of directory change watermarks
    SkillProposalId:
      type: string
      pattern: ^skp_[0-9a-f]{32}$
    AutomationAgentOutputBinding:
      type: object
      properties:
        source:
          anyOf:
            - type: object
              properties:
                kind:
                  type: string
                  enum:
                    - trigger_payload
              required:
                - kind
              additionalProperties: false
            - type: object
              properties:
                kind:
                  type: string
                  enum:
                    - agent_output
                step_id:
                  type: string
                  allOf:
                    - minLength: 1
                    - maxLength: 64
                    - pattern: ^[A-Za-z0-9_]+$
              required:
                - kind
                - step_id
              additionalProperties: false
            - type: object
              properties:
                kind:
                  type: string
                  enum:
                    - data_output
                step_id:
                  type: string
                  allOf:
                    - minLength: 1
                    - maxLength: 64
                    - pattern: ^[A-Za-z0-9_]+$
              required:
                - kind
                - step_id
              additionalProperties: false
        pointer:
          type: string
          allOf:
            - maxLength: 512
            - pattern: ^(?:\/(?:[^~/]|~[01])*)*$
      required:
        - source
        - pointer
      additionalProperties: false
    Union_210:
      type: string
      enum:
        - validation.malformed
        - validation.prompt_integrity_review_required
        - validation.not_found
        - validation.conflict
        - automation.source_event_conflict
        - automation.original_pending
        - automation.original_unavailable
        - validation.idempotency_conflict
        - validation.idempotency_in_progress
        - validation.payload_too_large
        - validation.range_too_large
        - auth.invalid_key
        - auth.authorization_unavailable
        - auth.request_admission_unavailable
        - auth.disabled_tenancy
        - policy.denied
        - budget.exceeded
        - model.no_eligible_model
        - model.credential_rejected
        - model.platform_supply_unavailable
        - model.platform_capacity_reached
        - billing.entitlement_unavailable
        - billing.usage_limit_reached
        - billing.payment_required
        - billing.seat_activation_unavailable
        - memory.not_found
        - memory.conflict
        - memory.read_only
        - memory.invalid_path
        - memory.backend_unavailable
        - memory.curation_failed
        - runtime.invalid_transition
        - runtime.primary_thread
        - retention.zdr_unsupported
        - runtime.checkpoint_expired
        - runtime.session_history_unavailable
        - runtime.harness_unavailable
        - runtime.harness_failed
        - runtime.runner_unavailable
        - runtime.provider_host_unavailable
        - runtime.lease_lost
        - runtime.start_timeout
        - runtime.allocation_failed
        - runtime.allocation_not_ready
        - runtime.provisioning_suspended
        - runtime.computer_unavailable
        - runtime.turn_deadline_exceeded
        - runtime.observation_gap
        - runtime.observation_conflict
        - runtime.attestation_invalid
        - runtime.harness_incompatible
        - runtime.target_mismatch
        - runtime.transcript_index_unavailable
        - runtime.internal
    UsageEntryId:
      type: string
      pattern: ^use_[0-9a-f]{32}$
    Union_266:
      anyOf:
        - $ref: '#/components/schemas/PrincipalId'
        - type: 'null'
    Union_267:
      anyOf:
        - type: string
          allOf:
            - minLength: 1
        - type: 'null'
    UsageTimestamp:
      type: string
      allOf:
        - maxLength: 24
        - pattern: ^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}\.\d{3}Z$
          x-checkfu-current-timestamp: true
          description: A canonical UTC ISO-8601 usage timestamp with millisecond precision.
    ToolInvocationId:
      type: string
      pattern: ^tinv_[0-9a-f]{32}$
    ManagedToolSelection:
      type: object
      properties:
        managed_tool_id:
          $ref: '#/components/schemas/ManagedToolId'
        managed_tool_release_id:
          $ref: '#/components/schemas/ManagedToolReleaseId'
      required:
        - managed_tool_id
        - managed_tool_release_id
      additionalProperties: false
    ManagedToolPrice:
      type: object
      properties:
        rate_card_id:
          $ref: '#/components/schemas/BillingRateCardId'
        price_microusd:
          type: integer
          allOf:
            - minimum: 0
            - maximum: 9007199254740991
        billing_basis:
          type: string
          enum:
            - valid_result
            - admitted_dispatch
        valid_empty_result_billable:
          type: boolean
      required:
        - rate_card_id
        - price_microusd
        - billing_basis
        - valid_empty_result_billable
      additionalProperties: false
      description: >-
        One published fixed price per logical invocation; polling and result
        recovery do not add calls.
    Objects_151:
      type: object
      properties:
        kind:
          type: string
          enum:
            - model
        model_routing_profile_id:
          anyOf:
            - $ref: '#/components/schemas/ModelRoutingProfileId'
            - type: 'null'
        candidate:
          $ref: '#/components/schemas/Objects_152'
        tokens:
          $ref: '#/components/schemas/Objects_86'
        measured_at:
          $ref: '#/components/schemas/UsageTimestamp'
        supply_class:
          $ref: '#/components/schemas/Union_268'
        basis:
          anyOf:
            - type: string
              enum:
                - admitted_maximum
      required:
        - kind
        - model_routing_profile_id
        - candidate
        - tokens
        - measured_at
        - supply_class
      additionalProperties: false
    Objects_153:
      type: object
      properties:
        tokens:
          type: integer
          minimum: 0
        model_spend_microusd:
          anyOf:
            - type: integer
              allOf:
                - minimum: 0
                - maximum: 9007199254740991
            - type: 'null'
        active_ms: false
        storage_mib_ms: false
        running_ms: false
        billed_microusd: false
      required:
        - tokens
      additionalProperties: false
    RunAttemptId:
      type: string
      pattern: ^ratt_[0-9a-f]{32}$
    EvaluationUsageOrigin:
      type: object
      properties:
        parent_kind:
          type: string
          allOf:
            - minLength: 1
        parent_id:
          type: string
          allOf:
            - minLength: 1
        slot:
          type: string
          allOf:
            - minLength: 1
      required:
        - parent_kind
        - parent_id
        - slot
      additionalProperties: false
      description: The parent and operation slot that own one non-Agent model evaluation.
    Objects_154:
      type: object
      properties:
        kind:
          type: string
          enum:
            - model_unit
        model_routing_profile_id:
          anyOf:
            - $ref: '#/components/schemas/ModelRoutingProfileId'
            - type: 'null'
        candidate:
          $ref: '#/components/schemas/Objects_152'
        usage:
          $ref: '#/components/schemas/Objects_155'
        measured_at:
          $ref: '#/components/schemas/UsageTimestamp'
        supply_class:
          $ref: '#/components/schemas/Union_268'
      required:
        - kind
        - model_routing_profile_id
        - candidate
        - usage
        - measured_at
        - supply_class
      additionalProperties: false
    Objects_156:
      type: object
      properties:
        tokens: false
        active_ms: false
        storage_mib_ms: false
        running_ms: false
        billed_microusd: false
        unit:
          $ref: '#/components/schemas/Union_269'
        quantity_millionths:
          type: integer
          minimum: 0
        model_spend_microusd:
          anyOf:
            - type: integer
              allOf:
                - minimum: 0
                - maximum: 9007199254740991
            - type: 'null'
      required:
        - unit
        - quantity_millionths
      additionalProperties: false
    SandboxComputeInterval:
      type: object
      properties:
        kind:
          type: string
          enum:
            - sandbox_compute
        provider:
          type: string
          allOf:
            - minLength: 1
        environment_id:
          $ref: '#/components/schemas/EnvironmentId'
        period_started_at:
          $ref: '#/components/schemas/UsageTimestamp'
        period_ended_at:
          $ref: '#/components/schemas/UsageTimestamp'
        active_ms:
          type: integer
          minimum: 0
      required:
        - kind
        - provider
        - environment_id
        - period_started_at
        - period_ended_at
        - active_ms
      additionalProperties: false
    SnapshotRetentionInterval:
      type: object
      properties:
        kind:
          type: string
          enum:
            - snapshot_retention
        checkpoint_id:
          $ref: '#/components/schemas/CheckpointId'
        provider:
          type: string
          allOf:
            - minLength: 1
        environment_id:
          $ref: '#/components/schemas/EnvironmentId'
        storage_mib:
          type: integer
          exclusiveMinimum: 0
        period_started_at:
          $ref: '#/components/schemas/UsageTimestamp'
        period_ended_at:
          $ref: '#/components/schemas/UsageTimestamp'
        retained_ms:
          type: integer
          minimum: 0
      required:
        - kind
        - checkpoint_id
        - provider
        - environment_id
        - storage_mib
        - period_started_at
        - period_ended_at
        - retained_ms
      additionalProperties: false
    SessionRuntimeInterval:
      type: object
      properties:
        kind:
          type: string
          enum:
            - session_runtime
        thread_id:
          anyOf:
            - $ref: '#/components/schemas/SessionThreadId'
            - type: 'null'
        placement:
          type: string
          enum:
            - hosted_sandbox
            - runner
            - cloudflare_durable_object
        period_started_at:
          $ref: '#/components/schemas/UsageTimestamp'
        period_ended_at:
          $ref: '#/components/schemas/UsageTimestamp'
        running_ms:
          type: integer
          minimum: 0
        producer_version:
          type: number
          enum:
            - 1
            - 2
            - 3
      required:
        - kind
        - thread_id
        - placement
        - period_started_at
        - period_ended_at
        - running_ms
      additionalProperties: false
    Union_270:
      anyOf:
        - type: object
          properties:
            tokens: false
            active_ms: false
            storage_mib_ms: false
            running_ms:
              type: integer
              minimum: 0
            billed_microusd:
              type: integer
              allOf:
                - minimum: 0
                - maximum: 9007199254740991
            rounding_remainder_millionths:
              type: integer
              minimum: 0
          required:
            - running_ms
            - billed_microusd
            - rounding_remainder_millionths
          additionalProperties: false
        - type: object
          properties:
            tokens: false
            active_ms: false
            storage_mib_ms: false
            running_ms:
              type: integer
              minimum: 0
            billed_microusd:
              type: 'null'
            rounding_remainder_millionths:
              type: 'null'
          required:
            - running_ms
            - billed_microusd
            - rounding_remainder_millionths
          additionalProperties: false
    SessionThreadId:
      type: string
      pattern: ^sthr_[0-9a-f]{32}$
    PrincipalId:
      type: string
      pattern: ^prin_[0-9a-f]{32}$
    ManagedToolId:
      type: string
      pattern: ^mtl_[0-9a-f]{32}$
    ManagedToolReleaseId:
      type: string
      pattern: ^mtrel_[0-9a-f]{32}$
    BillingRateCardId:
      type: string
      pattern: ^rate_[0-9a-f]{32}$
    ModelRoutingProfileId:
      type: string
      pattern: ^mrp_[0-9a-f]{32}$
    Objects_152:
      type: object
      properties:
        tier:
          $ref: '#/components/schemas/Union_128'
        provider:
          type: string
          pattern: ^[a-z0-9](?:[a-z0-9._-]{0,93})$
        model:
          type: string
          allOf:
            - minLength: 1
            - maxLength: 255
        context_window_tokens:
          type: integer
          exclusiveMinimum: 0
        native_capabilities:
          anyOf:
            - type: object
              properties:
                version:
                  type: number
                  enum:
                    - 1
                wire_format:
                  type: string
                  enum:
                    - openai_chat
                max_output_tokens:
                  type: integer
                  exclusiveMinimum: 0
                input_modalities:
                  type: array
                  prefixItems:
                    - type: string
                      enum:
                        - text
                        - image
                  minItems: 1
                  items:
                    type: string
                    enum:
                      - text
                      - image
                reasoning:
                  type: boolean
                thinking_levels:
                  $ref: '#/components/schemas/Objects_71'
                compatibility:
                  type: object
                  properties:
                    supportsStore:
                      type: boolean
                    supportsDeveloperRole:
                      type: boolean
                    supportsReasoningEffort:
                      type: boolean
                    supportsUsageInStreaming:
                      type: boolean
                    supportsFinishReason:
                      type: boolean
                    maxTokensField:
                      type: string
                      enum:
                        - max_tokens
                        - max_completion_tokens
                    requiresToolResultName:
                      type: boolean
                    requiresAssistantAfterToolResult:
                      type: boolean
                    requiresThinkingAsText:
                      type: boolean
                    requiresReasoningContentOnAssistantMessages:
                      type: boolean
                    thinkingFormat:
                      type: string
                      enum:
                        - openai
                        - openrouter
                        - deepseek
                        - together
                        - zai
                        - qwen
                        - string-thinking
                        - ant-ling
                    zaiToolStream:
                      type: boolean
                    supportsStrictMode:
                      type: boolean
                    supportsOpenAIGrammarTools:
                      type: boolean
                    supportsMidConvoSystemMessages:
                      type: boolean
                    supportsMidConvoToolAdditions:
                      type: boolean
                    supportsThinkingTokenBudget:
                      type: boolean
                    thinkingTokenBudgetField:
                      type: string
                      enum:
                        - thinking_token_budget
                        - thinking_budget
                        - thinking_budget_tokens
                  required:
                    - supportsStore
                    - supportsDeveloperRole
                    - supportsReasoningEffort
                    - supportsUsageInStreaming
                    - supportsFinishReason
                    - maxTokensField
                    - requiresToolResultName
                    - requiresAssistantAfterToolResult
                    - requiresThinkingAsText
                    - requiresReasoningContentOnAssistantMessages
                    - thinkingFormat
                    - zaiToolStream
                    - supportsStrictMode
                    - supportsOpenAIGrammarTools
                    - supportsMidConvoSystemMessages
                    - supportsMidConvoToolAdditions
                    - supportsThinkingTokenBudget
                  additionalProperties: false
              required:
                - version
                - wire_format
                - max_output_tokens
                - input_modalities
                - reasoning
                - thinking_levels
                - compatibility
              additionalProperties: false
            - type: object
              properties:
                version:
                  type: number
                  enum:
                    - 1
                wire_format:
                  type: string
                  enum:
                    - openai_responses
                max_output_tokens:
                  type: integer
                  exclusiveMinimum: 0
                input_modalities:
                  type: array
                  prefixItems:
                    - type: string
                      enum:
                        - text
                        - image
                  minItems: 1
                  items:
                    type: string
                    enum:
                      - text
                      - image
                reasoning:
                  type: boolean
                thinking_levels:
                  $ref: '#/components/schemas/Objects_71'
                compatibility:
                  type: object
                  properties:
                    supportsDeveloperRole:
                      type: boolean
                    supportsMidConvoSystemMessages:
                      type: boolean
                    supportsStrictMode:
                      type: boolean
                    supportsOpenAIGrammarTools:
                      type: boolean
                    supportsAdditionalTools:
                      type: boolean
                    supportsToolSearch:
                      type: boolean
                    supportsExplicitPromptCacheMode:
                      type: boolean
                    supportsMaxOutputTokens:
                      type: boolean
                  required:
                    - supportsDeveloperRole
                    - supportsMidConvoSystemMessages
                    - supportsStrictMode
                    - supportsOpenAIGrammarTools
                    - supportsAdditionalTools
                    - supportsToolSearch
                    - supportsExplicitPromptCacheMode
                    - supportsMaxOutputTokens
                  additionalProperties: false
              required:
                - version
                - wire_format
                - max_output_tokens
                - input_modalities
                - reasoning
                - thinking_levels
                - compatibility
              additionalProperties: false
            - type: object
              properties:
                version:
                  type: number
                  enum:
                    - 1
                wire_format:
                  type: string
                  enum:
                    - anthropic_messages
                max_output_tokens:
                  type: integer
                  exclusiveMinimum: 0
                input_modalities:
                  type: array
                  prefixItems:
                    - type: string
                      enum:
                        - text
                        - image
                  minItems: 1
                  items:
                    type: string
                    enum:
                      - text
                      - image
[...]
